# encoding: utf-8
require 'client_pages/version'
require 'open-uri'
require 'redcarpet'

module ClientPages
  autoload :Matcher, 'client_pages/matcher'
  autoload :Template, 'client_pages/template'
  autoload :Configuration, 'client_pages/configuration'

  module MarkdownContent
    autoload :ContentBuilder, 'client_pages/markdown_content/content_builder'
    autoload :Renderer, 'client_pages/markdown_content/renderer'
  end

  class << self
    extend Forwardable
    attr_accessor :configuration

    def_delegator MarkdownContent::Renderer, :render_content
    def_delegator Template, :templating

    def config
      self.configuration ||= Configuration.new
    end

    def configure
      yield(config)
    end

    def cache
      @cache ||= {}
    end
  end
end
