module ClientPages
  class Configuration
    attr_accessor :content_path, :remote, :remote_content_path, :caching, :raw_markdown
    attr_reader :render_options, :markdown_extensions

    def initialize
      @content_path = 'content'
      @render_options = {}
      @markdown_extensions = {}
    end

    def render_options=(options)
      render_options.merge!(options)
    end

    def markdown_extensions=(options)
      markdown_extensions.merge!(options)
    end

    def to_hash
      Hash[instance_variables.map { |name| [name[1..-1].to_sym, instance_variable_get(name)] }]
    end
  end
end
