module ClientPages
  class Matcher
    attr_accessor :tag, :line

    def initialize(tag, line)
      @tag, @line = tag, line
    end

    def match?(attribute, match)
      !!line.match(/<#{tag}[^>]*#{attribute}="#{match}"/i)
    end

    def match_all?(attributes)
      attributes.keys.all? { |key| match?(key, attributes[key]) }
    end

    def match_any?(attribute, match)
      !!line.match(/#{attribute}="#{match}"/i)
    end

    def includes?(pattern)
      !!line.match(pattern)
    end

    def find(type)
      if block_given? && includes?(tag_pattern[type])
        line.gsub(tag_pattern[type]) { |match| yield match }
      else
        line
      end
    end

    private

    def tag_pattern
      { open: /<#{tag}[^>]*>/, close: /<\/#{tag}[^>]*>/ }
    end
  end
end
